PKCS5_PBKDF2_HMAC< T > Class Template Reference

PBKDF2 from PKCS #5, T should be a HashTransformation class. More...

`#include <pwdbased.h>`

Inheritance diagram for PKCS5_PBKDF2_HMAC< T >:

## Public Member Functions

size_t | MaxDerivedKeyLength () const
bool | UsesPurposeByte () const
unsigned int | DeriveKey (byte *derived, size_t derivedLen, byte purpose, const byte *password, size_t passwordLen, const byte *salt, size_t saltLen, unsigned int iterations, double timeInSeconds=0) const
| derive key from password More...

## Detailed Description

### template<class T>
class PKCS5_PBKDF2_HMAC< T >

PBKDF2 from PKCS #5, T should be a HashTransformation class.

Definition at line 38 of file pwdbased.h.

## Member Function Documentation

template<class T >

unsigned int PKCS5_PBKDF2_HMAC< T >::DeriveKey | ( | byte * | derived,
|  | size_t | derivedLen,
|  | byte | purpose,
|  | const byte * | password,
|  | size_t | passwordLen,
|  | const byte * | salt,
|  | size_t | saltLen,
|  | unsigned int | iterations,
|  | double | timeInSeconds = `0`
| ) |  | const

virtual

derive key from password

If timeInSeconds != 0, will iterate until time elapsed, as measured by ThreadUserTimer Returns actual iteration count, which is equal to iterations if timeInSeconds == 0, and not less than iterations otherwise.

Implements PasswordBasedKeyDerivationFunction.

Definition at line 86 of file pwdbased.h.

References HashTransformation::CalculateDigest(), HMAC_Base::DigestSize(), HashTransformation::Final(), and HMAC_Base::Update().

The documentation for this class was generated from the following file:

- pwdbased.h